#! /bin/bash

check_passwd(){
	echo "******************start**********************"
	cat /etc/shadow | head -n1 > /root/.password
	if [ -f "/root/.passwd_md5" ];then
		orig_md5=`cat /root/.passwd_md5`
		cat /etc/shadow | head -n1 > /root/.passwd
		new_md5=`md5sum /root/.passwd | awk '{print $1}'`
		rm /root/.passwd
		echo $new_md5
		if [ "X$new_md5" = "X$orig_md5" ];then
			echo "random_change" > /root/.chpasswd
		else
			echo "user_change" > /root/.chpasswd
		fi
	fi
}

change_passwd(){
	if [ -f "/root/.chpasswd" ];then
		value=`cat /root/.chpasswd`
		if [ "X$value" = "Xuser_change" ];then
			if [ -f "/root/.password" ];then
				rm /root/.password
				rm /root/.passwd_md5
			fi
			exit
		fi
	fi
	new_passwd=`< /dev/urandom tr -dc _A-Z-a-z-0-9 | head -c${1:-16}`
	echo $new_passwd
	echo root:$new_passwd | chpasswd
	cat /etc/shadow | head -n1 > /root/.password
	if [ -f "/root/.password" ];then
		passwd_md5=`md5sum /root/.password | awk '{print $1}'`
		echo $passwd_md5 > /root/.passwd_md5
		rm /root/.password
		echo $passwd_md5
	fi
}

main(){
	livecd=`cat /boot/grub/grub.cfg | grep "boot=live"`
	if [ "X$livecd" != "X" ];then
		exit 0
	fi

	check_passwd
	change_passwd
}

main
